/**********************************************************
 * File: main.c
 * Created at Thu Jul 15 16:14:17 1999 by pk // aaz@ruxy.org.ru
 * qico main
 * $Id: main.c,v 1.3 2000/07/22 16:00:07 lev Exp $
 **********************************************************/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <locale.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <signal.h>
#include <sys/utsname.h>
#include <errno.h>
#include <ctype.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <fcntl.h>
#include "ftn.h"
#include "ver.h"
#include "qconf.h"
#include "tty.h"
#include "mailer.h"
#include "qipc.h"
#include "globals.h"

#ifdef Q_DEBUG
#define sline log
#endif

#define IP_D 0

char *configname=CONFIG;
subst_t *psubsts;
int qipcr_msg;

void usage(char *ex)
{
	printf("%s-%s copyright (c) pavel kurnosoff, 1999-2000\n"
		   "usage: %s [<options>] [<node>] [<files>]\n"
 		   "<node>       must be in ftn-style (i.e. zone:net/node[.point])!\n" 
		   "-h           this help screen\n"
		   "-I<config>   override default config\n\n"  
		   "-d           start in daemon (originate) mode\n"
 		   "-a<type>     start in answer mode with <type> session, type can be:\n"
		   "                       auto - autodetect\n"
		   "             **EMSI_INQC816 - EMSI session without init phase\n"
		   "                      tsync - FTS-0001 session (unsuppported)\n"
		   "                     yoohoo - YOOHOO session (unsuppported)\n"
 		   "-i<host>     start TCP/IP connection to <host> (node must be specified!)\n"
		   "-c           start modem call to <node> from command line\n"
		   "-n           compile nodelists\n"
		   "\n", progname, version, ex);
	exit(0);
}

void stopit(int rc)
{
	vidle();qqreset();
	log("exiting with rc=%d", rc);log_done();
#if IP_D	
	if(is_ip) qlerase();
#endif	
	qipc_done();
	exit(rc);
}

void sigerr(int sig)
{
	char *sigs[]={"","HUP","INT","QUIT","ILL","TRAP","IOT","BUS","FPE",
				  "KILL","USR1","SEGV","USR2","PIPE","ALRM","TERM"};
	signal(sig, SIG_DFL);
	msgctl(qipcr_msg, IPC_RMID, 0);
	bso_done();
	log("got SIG%s signal",sigs[sig]);
#if IP_D	
	if(is_ip) qlerase();
#endif
	if(getpid()==islocked(cfgs(CFG_PIDFILE))) lunlink(ccs);
	log_done();
	tty_close();
	qqreset();sline("");title("");
	qipc_done();
	switch(sig) {
	case SIGSEGV:
	case SIGFPE:
	case SIGBUS:
		abort();
	default:
		exit(1);
	}
}

void sigchild(int sig)
{
	int rc, wr;
	signal(SIGCHLD, sigchild);
	wr=wait(&rc);
	if(wr<0) log("wait() returned %d (%d)", wr, rc);
	rc=WEXITSTATUS(rc)&S_MASK;
	if(rc==S_OK || rc==S_REDIAL) {
		do_rescan=1;
	}
}

void sighup(int sig)
{
	signal(SIGHUP, sighup);
	log("got SIGHUP, trying to reread configs...");
	killsubsts(&psubsts);
	killconfig();
	if(!readconfig(configname)) {
		log("there was some errors parsing config, exiting");
		stopit(0);
	}
	psubsts=parsesubsts(cfgfasl(CFG_SUBST));
	do_rescan=1;
}


void sendrpkt(char what, pid_t pid, char *fmt, ...)
{
	char buf[MSG_BUFFER];
	int rc;
	va_list args;
	
	*((int *)buf)=pid;
	buf[4]=what;
	va_start(args, fmt);
	rc=vsnprintf(buf+5, MSG_BUFFER-1, fmt, args);
	va_end(args);
	msgsnd(qipcr_msg, buf, rc+6, IPC_NOWAIT);
}	

void alarmer(int i)
{
}
	
void daemon_mode()
{
	int t_dial=0, t_rescan=0; 
	int rc=1, dable, f, w, res, set;
	char *port, buf[MSG_BUFFER], *p;
	sts_t sts;
	pid_t chld;
	qitem_t *current=q_queue, *i;
	key_t qipcr_key;
	time_t t;
	ftnaddr_t fa;
	slist_t *sl;

	if(getppid()!=1) {
		signal(SIGTTOU, SIG_IGN);
		signal(SIGTTIN, SIG_IGN);
		signal(SIGTSTP, SIG_IGN);
		if((rc=fork())>0) 
			exit(0);
		if(rc<0) {
			log("can't spawn daemon!");
			exit(1);
		}
		setsid();
	}

	signal(SIGINT, sigerr);	
	signal(SIGTERM, sigerr);
/* 	signal(SIGSEGV, sigerr); */
	signal(SIGFPE, sigerr);
	signal(SIGCHLD, sigchild);
	signal(SIGHUP, sighup);

	if(cfgs(CFG_PIDFILE)) {
		if(!lockpid(ccs)) {
			log("another daemon exists or can't create pid file!");
			exit(1);
		}
	}
	if((qipcr_key=ftok(QIPC_KEY,QR_MSGQ))<0) {
		log("can't get key");
		exit(1);
	}
	if((qipcr_msg=msgget(qipcr_key, cfgi(CFG_IPCPERM) | IPC_CREAT | IPC_EXCL))<0) {
		log("can't create message queue (may be another daemon is running?)");
		exit(1);
	}

	if(!bso_init(cfgs(CFG_OUTBOUND), cfgal(CFG_ADDRESS)->addr.z)) {
		log("can't init BSO");
		exit(1);
	}

	if(!log_init(cfgs(CFG_MASTERLOG),NULL)) {
		log("can't open master log %s!", ccs);
		exit(1);
	}
	log("%s-%s/%s daemon started",progname,version,osname);
	t_rescan=cfgi(CFG_RESCANPERIOD);
	while(1) {
		title("Queue manager [%d]", cfgi(CFG_RESCANPERIOD)-t_rescan);
		if(t_rescan>=cci || do_rescan) {
			do_rescan=0;
			sline("Rescanning outbound...");
			if(!q_rescan(&current)) 
				log("can't rescan outbound %s!", cfgs(CFG_OUTBOUND));
			t_rescan=0;
		}
		sline("Waiting %d...", cfgi(CFG_DIALDELAY)-t_dial);
		if(t_dial>=cci) {
			t_dial=0;
			dable=0;

			port=tty_findport(cfgsl(CFG_PORT),cfgs(CFG_NODIAL));			
			if(!port || !q_queue) dable=1;
			i=q_queue;
#ifdef Q_DEBUG			
			log("dabl");
#endif
			while(!dable && i) {
				f=current->flv;
				w=current->what;
				if(f&Q_ANYWAIT) 
					if(t_exp(current->onhold)) {
						current->onhold=0;
						f&=~Q_ANYWAIT;
					}
				if(f&Q_UNDIAL && cfgi(CFG_CLEARUNDIAL)!=0) {
					bso_getstatus(&current->addr, &sts);
					if (t_exp(sts.utime)) {
						sts.flags&=~Q_UNDIAL;
						sts.try=0;
						sts.utime=0;
						bso_setstatus(&current->addr, &sts);
                                           f&=~Q_UNDIAL;
					}
				}
 
				if(falist_find(cfgal(CFG_ADDRESS), &current->addr) ||
				   f&Q_UNDIAL ||
				   !(f&Q_NORM) ||
				   (f&Q_WAITR && !(w&(~T_REQ))) ||
				   (f&Q_WAITX && !(w&(~T_ARCMAIL))) ||
				   (f&Q_WAITA)) {
					current=current->next;
					if(!current) current=q_queue;
					i=i->next;
					continue;
				}
#ifdef Q_DEBUG			
				log("quering");
#endif
				rc=query_nodelist(&current->addr,cfgs(CFG_NLPATH),&rnode);
#ifdef Q_DEBUG			
				log("querynl");
#endif
				switch(rc) {
				case 1:log("can't query nodelist, index error");break;
				case 2:log("can't query nodelist, nodelist error");break;
				case 3:log("index is older than the list, need recompile");break;
				}
				if(!rnode) {
					rnode=calloc(1,sizeof(ninfo_t));
					falist_add(&rnode->addrs, &current->addr);
					rnode->name=strdup("Unknown");
					rnode->phone=strdup("");
				}
				phonetrans(rnode->phone, cfgsl(CFG_PHONETR));
#ifdef Q_DEBUG			
				log("%s %s %s [%d]", ftnaddrtoa(&current->addr),
					rnode?rnode->phone:"$",rnode->haswtime?rnode->wtime:"$",rnode->hidnum);
#endif
				applysubst(rnode, psubsts);
				rnode->tty=strdup(baseport(port));
				if(can_dial(rnode, current->flv&Q_IMM) &&
				   checktimegaps(cfgs(CFG_CANCALL))) {
					dable=1;current->flv|=Q_DIAL;
					chld=fork();
#ifdef Q_DEBUG			
					log("forking %s",ftnaddrtoa(&current->addr));
#endif
					
					if(chld==0) {
						if(!bso_locknode(&current->addr)) exit(S_BUSY);
						log_done();
						if(!log_init(cfgs(CFG_LOG),rnode->tty)) {
							fprintf(stderr, "can't init log %s!",ccs);
							exit(S_BUSY);
						}
						if(rnode->hidnum) {
							title("Calling %s #%d, %s",
								  rnode->name, rnode->hidnum,
								  ftnaddrtoa(&current->addr));
							log("calling %s #%d, %s (%s)", rnode->name, rnode->hidnum,	
								ftnaddrtoa(&current->addr),
								rnode->phone);
						} else {								
							title("Calling %s, %s",
								  rnode->name, ftnaddrtoa(&current->addr));
							log("calling %s, %s (%s)", rnode->name,
								ftnaddrtoa(&current->addr),
								rnode->phone);
						}								
						rc=do_call(&current->addr, rnode->phone,
								   port);
						log_done();
							
						if(!log_init(cfgs(CFG_MASTERLOG),NULL)) {
							fprintf(stderr, "can't init log %s.%s!",
									ccs, port);
						}
							
						if(rc&S_ANYHOLD) {
							log("calls to %s delayed for %d min",
								ftnaddrtoa(&current->addr), cfgi(CFG_WAITHRQ));
							bso_getstatus(&current->addr, &sts);
							if(rc&S_HOLDA) sts.flags|=Q_WAITA;
							if(rc&S_HOLDR) sts.flags|=Q_WAITR;
							if(rc&S_HOLDX) sts.flags|=Q_WAITX;
							sts.htime=t_set(cci*60);
							bso_setstatus(&current->addr, &sts);
						}
						if(rc!=S_BUSY) t_rescan=cfgi(CFG_RESCANPERIOD)-1;
						switch(rc&S_MASK) {
						case S_BUSY: break;
						case S_OK:
							bso_getstatus(&current->addr, &sts);
							sts.try=0;
							bso_setstatus(&current->addr, &sts);
							break;
						case S_UNDIAL:
							bso_getstatus(&current->addr, &sts);
							sts.flags|=Q_UNDIAL;
							sts.utime=t_set(cfgi(CFG_CLEARUNDIAL)*60);
							bso_setstatus(&current->addr, &sts);
							break;
						case S_REDIAL:
							bso_getstatus(&current->addr, &sts);
							if(++sts.try>=cfgi(CFG_MAX_FAILS)) {
								sts.flags|=Q_UNDIAL;
								log("maximum tries count reached, %s undialable",
									ftnaddrtoa(&current->addr));
							}
							bso_setstatus(&current->addr, &sts);
							break;
						}
						bso_unlocknode(&current->addr);
						vidle();log_done();
/* 						qipc_done(); */
						exit(rc);
					}
					if(chld<0) log("can't fork() caller!");
				} else current->flv&=~Q_DIAL;
				nlkill(&rnode);
#ifdef Q_DEBUG
				log("nlkill");
#endif
				current=current->next;
				if(!current) current=q_queue;
				i=i->next;
			} 
		}
		signal(SIGALRM, alarmer);
		alarm(1);
		t=time(NULL);
		while((time(NULL)-t)<1) {
			rc=msgrcv(qipcr_msg, buf, MSG_BUFFER-1, 1, 0);
			if(rc>=5) {
				chld=*((int *)buf+1);
				rc=1;
				if(buf[8]==QR_POLL || buf[8]==QR_REQ ||
				   buf[8]==QR_INFO || buf[8]==QR_SEND ||
				   buf[8]==QR_STS || buf[8]==QR_KILL) {
					if(!parseftnaddr(buf+9, &fa, &DEFADDR, 0)) {
						log("can't parse address '%s'!", buf+9);
						sendrpkt(1,chld,"can't parse address '%s'!", buf+9);
						rc=0;
					}
				}
				if(rc) switch(buf[8]) {
				case QR_QUIT:
					sendrpkt(0,chld,"");
					msgctl(qipcr_msg, IPC_RMID, 0);
					bso_done();
					log("exiting by request");
#if IP_D	
					if(is_ip) qlerase();
#endif
					if(cfgs(CFG_PIDFILE)) {
						if(getpid()==islocked(ccs)) lunlink(ccs);
					}
					log_done();
					qqreset();sline("");title("");
					qipc_done();
					exit(0);
				case QR_CONF:
					log("trying to reread configs by request...");
					killsubsts(&psubsts);
					killconfig();
					if(!readconfig(configname)) {
						log("there was some errors parsing config, exiting");
						sendrpkt(1,chld,"bad config, terminated");
						stopit(0);
					}
					psubsts=parsesubsts(cfgfasl(CFG_SUBST));
					do_rescan=1;					
					sendrpkt(0,chld,"");
					break;
				case QR_SCAN:
					do_rescan=1;					
					sendrpkt(0,chld,"");
					break;
				case QR_POLL:
					if(bso_locknode(&fa)) {
						log("poll for %s", ftnaddrtoa(&fa));
						sendrpkt(0,chld,"");
						rc=bso_poll(&fa);
						bso_unlocknode(&fa);
						do_rescan=1;
					} else {
						log("can't create poll for %s!",
							ftnaddrtoa(&fa));
						sendrpkt(1,chld,"can't create poll for %s",
								 ftnaddrtoa(&fa));
					}
					break;
				case QR_KILL:
					if(bso_locknode(&fa)) {
						log("kill %s", ftnaddrtoa(&fa));
						sendrpkt(0,chld,"");
						simulate_send(&fa);
						bso_unlocknode(&fa);
						do_rescan=1;
					} else {
						log("can't kill %s!",
							ftnaddrtoa(&fa));
						sendrpkt(1,chld,"can't create kill %s",
								 ftnaddrtoa(&fa));
					}
					break;
				case QR_STS:
					p=buf+9+strlen(buf+9)+1;
					rc=1;res=0;set=0;
					while(*p && rc) {
						switch(*p) {
						case 'W': set|=Q_WAITA;break;
						case 'I': set|=Q_IMM;break;
						case 'U': set|=Q_UNDIAL;break;
						case 'w': res|=Q_ANYWAIT;break;
						case 'i': res|=Q_IMM;break;
						case 'u': res|=Q_UNDIAL;break;
						default:
							log("unknown status action: %c", *p);
							sendrpkt(1,chld,
									 "unknown status action: %c", *p);
							rc=0;
						}
						p++;
					}
					if(rc) {
						bso_getstatus(&fa, &sts);
						sts.flags|=set;sts.flags&=~res;
						log("changing status of %s to 0x%08x",
							ftnaddrtoa(&fa), sts.flags);
						if(set&Q_WAITA && !(res&Q_ANYWAIT))
							sts.htime=t_set(cfgi(CFG_WAITHRQ)*60);
						if(set&Q_UNDIAL) sts.utime=t_set(cfgi(CFG_CLEARUNDIAL)*60);
						if(res&Q_UNDIAL) sts.try=0;
						bso_setstatus(&fa, &sts);
						sendrpkt(0,chld,"");
						do_rescan=1;
					}
					break;
				case QR_REQ:
					if(bso_locknode(&fa)) {
						sl=NULL;p=buf+9+strlen(buf+9)+1;
						while(strlen(p)){
							log("requested '%s' from %s",p,
								ftnaddrtoa(&fa));
							slist_add(&sl, p);
							p+=strlen(p)+1;
						}
						rc=bso_request(&fa, sl);
						slist_kill(&sl);
						bso_unlocknode(&fa);
						sendrpkt(0,chld,"");
						do_rescan=1;
					} else {
						log("can't lock node %s!",
							ftnaddrtoa(&fa));
						sendrpkt(1,chld,"can't lock node %s",
								 ftnaddrtoa(&fa));
					}
					break;
				case QR_SEND:
					p=buf+9+strlen(buf+9)+1;
					switch(*p) {
					case 'N': rc=F_NORM;break;
					case 'C': rc=F_CRSH;break;
					case 'D': rc=F_DIR;break;
					case 'H': rc=F_HOLD;break;
					default: rc=F_ERR;
					}
					if(rc==F_ERR) {
						log("unknown flavour - '%c'",C0(*p));
						sendrpkt(1,chld,"unknown flavour %c",C0(*p));
						break;
					}
					p+=strlen(p)+1;
					if(bso_locknode(&fa)) {
						sl=NULL;
						while(strlen(p)){
							log("attaching '%s' to %s%s",
								(p[0]=='^')?p+1:p,
								ftnaddrtoa(&fa),
								(p[0]=='^')?" (k/s)":"");
							slist_add(&sl, p);
							p+=strlen(p)+1;
						}
						rc=bso_attach(&fa, rc, sl);
						slist_kill(&sl);
						bso_unlocknode(&fa);
						sendrpkt(0,chld,"");
						do_rescan=1;
					} else {
						log("can't lock node %s!",
							ftnaddrtoa(&fa));
						sendrpkt(1,chld,"can't lock node %s",
								 ftnaddrtoa(&fa));
					}
					break;
				case QR_INFO:
					rc=query_nodelist(&fa,cfgs(CFG_NLPATH),&rnode);
					if(rc) {
						log("nodelist query error!");
						sendrpkt(1, chld, "nodelist query error!");
						break;
					}
					if(rnode) {
						log("returned info about %s (%s)",
							rnode->name, ftnaddrtoa(&fa));
						sendrpkt(0, chld, "%s%c%s%c%s%c%s%c%s%c%s%c%d%c",
								 ftnaddrtoa(&fa), 0,
								 rnode->name, 0, rnode->place, 0,
								 rnode->sysop, 0, rnode->phone, 0,
								 rnode->flags, 0, rnode->speed, 0
							);
						nlkill(&rnode);
					} else {
						log("%s not found in nodelist!",
							ftnaddrtoa(&fa));
						sendrpkt(1, chld, "%s not found in nodelist!",
								 ftnaddrtoa(&fa));
					}
					break;
				default:
					log("got unsupported packet type: %c", C0(buf[8]));
				}
			}
		}
		alarm(0);
		t_dial++;t_rescan++;
		if(do_rescan) t_dial=0;
	}
}

void killdaemon(int sig)
{
	FILE *f;
	pid_t pid;
	if(!cfgs(CFG_PIDFILE)) {
		fprintf(stderr, "no pidfile defined\n");
		return;
	}
	f=fopen(cfgs(CFG_PIDFILE), "rt");
	if(!f) {
		fprintf(stderr, "can't open pid file - no daemon killed!\n");
		return;
	}		
	fscanf(f, "%d", &pid);fclose(f);
	if(kill(pid, sig))
		fprintf(stderr, "can't send signal!\n");
	else
		fprintf(stderr, "ok!\n");
}

void getsysinfo()
{
	struct utsname uts;
	char tmp[MAX_STRING];
	if(uname(&uts)) return;
	sprintf(tmp, "%s-%s (%s)", uts.sysname, uts.release, uts.machine);
	osname=strdup(tmp);
}


void answer_mode(int type)
{
	int rc, spd;char *cs;
	struct sockaddr_in sa;int ss=sizeof(sa);

	rnode=calloc(1, sizeof(ninfo_t));
	is_ip=!isatty(0);
#if IP_D	
	sprintf(ip_id, "ip%d", getpid());
#else
	sprintf(ip_id, "ipd");
#endif
	rnode->tty=strdup(is_ip?"tcpip":basename(ttyname(0)));
	rnode->options|=O_INB;
	if(!log_init(cfgs(CFG_LOG),rnode->tty)) {
		printf("can't open log %s!\n", ccs);
		exit(0);
	}
	signal(SIGINT, SIG_IGN);
	signal(SIGTERM, sigerr);
	signal(SIGSEGV, sigerr);
	signal(SIGFPE, sigerr);
	
	if(!bso_init(cfgs(CFG_OUTBOUND), cfgal(CFG_ADDRESS)->addr.z)) {
		log("can't init BSO");stopit(1);
	}

	log("answering incoming call");vidle();
	if(is_ip && !getpeername(0,(struct sockaddr *)&sa,&ss)) {
		log("remote is %s", inet_ntoa(sa.sin_addr));
		spd=TCP_SPEED;
	} else {	
		cs=getenv("CONNECT");spd=cs?atoi(cs):0;
		if(cs && spd) {
			log("*** CONNECT %s", cs);
		} else {
			log("*** CONNECT Unknown");spd=300;
		}
	}
	if((cs=getenv("CALLER_ID")) && strcasecmp(cs,"none"))
	   log("caller-id: %s", cs);
	tty_setattr(0);
	tty_nolocal();
	rc=session(0, type, NULL, spd);
	tty_cooked();
	title("Waiting...");
	vidle();
	sline("");
	bso_done();
	stopit(rc);
}	

int force_call(ftnaddr_t *fa)                                                  
{                                                                              
	char *port=tty_findport(cfgsl(CFG_PORT),cfgs(CFG_NODIAL));
	int rc;
	rc=query_nodelist(fa,cfgs(CFG_NLPATH),&rnode);
	if (!rnode) return 0;
	phonetrans(rnode->phone, cfgsl(CFG_PHONETR));
	rnode->tty=strdup(baseport(port));
	if(!log_init(cfgs(CFG_LOG),rnode->tty)) {
        printf("can't open log %s!\n", ccs);
        exit(0);
	}
	rc=do_call(fa, rnode->phone,port);
	return rc;
}
                                                                              

int main(int argc, char *argv[], char *envp[])
{
	int c, daemon=-1, rc, sesstype=SESSION_AUTO;
	char *hostname=NULL;
	ftnaddr_t fa;

#ifndef FREE_BSD
	setargspace(argv,envp);
#endif
 	setlocale(LC_ALL, "");	 

	while((c=getopt(argc, argv, "hI:da:ni:c"))!=EOF) {
		switch(c) {
		case 'c':                                                       
			daemon=12;
			break;
		case 'i':
			hostname=optarg;
			break;
		case 'h':
			usage(argv[0]);
		case 'I':
			configname=optarg;
			break;
		case 'd':
			daemon=1;
			break;
		case 'a':
			daemon=0;
			sesstype=SESSION_AUTO;
			if(!strncasecmp(optarg, "**emsi", 6)) sesstype=SESSION_EMSI;
			if(!strncasecmp(optarg, "tsync", 5)) sesstype=SESSION_FTS0001;
			if(!strncasecmp(optarg, "yoohoo", 6)) sesstype=SESSION_YOOHOO;
			break;
		case 'n':
			daemon=2;
			break;
		}
	}

	if(!hostname && daemon<0) usage(argv[0]);

	getsysinfo();
	if(!readconfig(configname)) {
		log("there was some errors parsing %s, aborting",
				configname);
		exit(EXC_BADCONFIG);
	}

	psubsts=parsesubsts(cfgfasl(CFG_SUBST));
#ifdef C_DEBUG
	dumpconfig();
	{
		subst_t *s;
		dialine_t *l;
		for(s=psubsts;s;s=s->next) {
			printf("subst for %s [%d]\n", ftnaddrtoa(&s->addr), s->nhids);				
			for(l=s->hiddens;l;l=l->next)
				printf(" * %s,%s,%d\n",l->phone,l->timegaps,l->num);
		}
	}
	printf("...press any key...\n");getchar();
#endif	

	if(daemon==0 || daemon==1 || daemon==12)
		if(!qipc_init()) log("can't create ipc key!");

	if(hostname || daemon==12) 
		if(!parseftnaddr(argv[optind], &fa, &DEFADDR, 0)) {
			log("%s: can't parse address '%s'!", argv[0],
				argv[optind]);
			exit(1);
		}

	if(hostname) {
		is_ip=1;
		rnode=calloc(1,sizeof(ninfo_t));
#if IP_D	
		sprintf(ip_id, "ip%d", getpid());
#else
		sprintf(ip_id, "ipd");
#endif
		rnode->tty="tcpip";
		if(!log_init(cfgs(CFG_LOG),rnode->tty)) {
			log("can't open log %s!", ccs);
			exit(1);
		}
		signal(SIGINT, sigerr);
		signal(SIGTERM, sigerr);
		signal(SIGSEGV, sigerr);
		
		if(!bso_init(cfgs(CFG_OUTBOUND), cfgal(CFG_ADDRESS)->addr.z)) {
			log("can't init BSO");stopit(1);
		}
		tcp_call(hostname, &fa);
		
		bso_done();
		stopit(0);
	}

	if(daemon==12) {
		if(!bso_init(cfgs(CFG_OUTBOUND), cfgal(CFG_ADDRESS)->addr.z)) {
			log("%s: can't init bso!", argv[0]);
			exit(1);
		}
		if (bso_locknode(&fa)) {
			signal(SIGINT, sigerr);
			signal(SIGTERM, sigerr);
			signal(SIGSEGV, sigerr);
			rc=force_call(&fa);
			bso_unlocknode(&fa);
		} else rc=0;
		if(rc) log("%s: can't call to %s", argv[0],ftnaddrtoa(&fa));
		bso_done();
		stopit(rc);
	}
	switch(daemon) {
	case 1:
		daemon_mode();break;
	case 0:
		answer_mode(sesstype);break;
	case 2:
		compile_nodelists();break;
	}
	
	return 0;
}
	
	
